#!/bin/sh
TIMERS=/etc/enigma2/timers.xml
TIMERSTMP=/etc/enigma2/timers.tmp
RECORD=/etc/enigma2/record.sh
SERVICEREF=/etc/enigma2/serviceref.lst
USERBOUQUET=/etc/enigma2/userbouquet.favourites.tv
cp $USERBOUQUET $SERVICEREF
dos2unix $SERVICEREF
sed -ie s!"#SERVICE "!!g $SERVICEREF
sed -ie s!"#NAME Favourites (TV)"!!g $SERVICEREF
sed '/^[ 	]*$/d' < $SERVICEREF > $TIMERSTMP && mv $TIMERSTMP $SERVICEREF
# now we have plain serviceref list !

#
REPEATED="0"
AFTEREVENT="nothing"
DISABLED="0"
JUSTPLAY="0"
# if nothing passed will record 2h
LATER=120
EIT="0"


# processing time
CDATE=`date -u`
CSEC=`date -u +'%s'`
CHOUR=`date -u +'%H'`
CMINUTE=`date -u +'%M'`
CMONTH=`date -u +'%m'`
CMONTHDAY=`date -u +'%d'`
CWEEKDAY=`date -u +'%w'`
#echo "Current time in seconds since 1970: $CSEC"
LSEC=`expr $LATER "*" 60`
#echo "Seconds in the Future $LSEC"
LSEC=`expr $LSEC "+" $CSEC`



# check for Channel 
if  [  ! $1 ]; then
    echo "No Channel passed will use 1!"
    CHANNEL="1"
else
    CHANNEL=$1
fi
    echo "Channel for recording is $CHANNEL"

# check for begin
if  [  ! $2 ]; then
    echo "No time passed for beginning recording using current time !"
    BEGIN=$CSEC
else
    BEGIN=`date -d $2 +'%s'`
fi
echo "Time for beginning of record will be $BEGIN in epoch time"
# check for end
if  [  ! $3 ]; then
    echo "No time passed for ending recording using begin time + 2h!"
    LSEC=`expr $LATER "*" 60`
    #echo "Seconds in the Future $LSEC"
    LSEC=`expr $LSEC "+" $BEGIN`
    END=$LSEC
else
    END=`date -d $3 +'%s'`
fi
echo "Time for ending of record will be $END in epoch time"
# check for name
if  [  ! $4 ]; then
    NAME="Recording"
else
    NAME=$4
fi
# check for description
if  [  ! $5 ]; then
    DESCRIPTION="planned by shell script"
else
    DESCRIPTION=$5
fi

# getting serrviceref
head -$CHANNEL $SERVICEREF | tail -n 1 - > $TIMERSTMP
SERVICEREF=`cat $TIMERSTMP`
echo "Serviceref if $SERVICEREF"
echo "Killing enigma to write to $TIMERS - will be fixed later"
killall enigma2

if [ ! -f $TIMERS ]; then
#   echo "$TIMERS doesn't exist, adding header"
   echo '<?xml version="1.0" ?>' > $TIMERS
   echo "<timers>" >> $TIMERS
else
#   echo "$TIMERS exists already, removing header and tail"
   sed -ie s!'<?xml version="1.0" ?>'!!g $TIMERS
   sed -ie s!"<timers>"!!g $TIMERS
   sed -ie s!"</timers>"!!g $TIMERS
   cp $TIMERS $TIMERSTMP
#   cat $TIMERSTMP
   echo '<?xml version="1.0" ?>' > $TIMERS
   echo "<timers>" >> $TIMERS
   cat $TIMERSTMP >> $TIMERS
   rm $TIMERSTMP
fi
echo '<timer begin="'$BEGIN'" end="'$END'" serviceref="'$SERVICEREF'" repeated="'$REPEATED'" name="'$NAME'" description="'$DESCRIPTION'" afterevent="'$AFTEREVENT'" eit="'$EIT'" disabled="'$DISABLED'" justplay="'$JUSTPLAY'">' >> $TIMERS
echo "</timer>"  >> $TIMERS
echo "</timers>"  >> $TIMERS
#cat $TIMERS
# removing empty lines
sed '/^[ 	]*$/d' < $TIMERS > $TIMERSTMP && mv $TIMERSTMP $TIMERS
exit 0
